#load "pts.cmo";;
#load "ptslex.cmo";;
#load "ptsparse.cmo";;
open Pts.MY_PTS;;
open Format;;
let cenv=ref ([]:env);;
let prt t=print !cenv t;;
#install_printer prt;;
#install_printer dump;;

let read env str=
   let buf=(Lexing.from_string (str^".")) in
  try
    let rt=Ptsparse.sterm Ptslex.token buf in unname env rt
  with Parsing.Parse_error | Failure "lexing: empty token"->
  failwith (sprintf "Syntax error char %d" (Lexing.lexeme_start buf));;

let read_file str=let chan=open_in str in 
  let buf=Lexing.from_channel chan in
  let prg= try Ptsparse.parse_all Ptslex.token buf with 
  Parsing.Parse_error | Failure "lexing: empty token"->
    let cpos=(Lexing.lexeme_start buf)- !Ptslex.bline in
    close_in chan; 
    failwith (sprintf "Syntax error line %d char %d" !Ptslex.nline cpos) in
  close_in chan;read_prog prg;;


