{
open Ptsparse;;
let nline=ref 1;;
let bline=ref 0;;
let newline buf=incr nline;bline:=Lexing.lexeme_end buf;;
let reset ()=nline:=1;bline:=0;;
}

let letter = [ 'a' - 'z'] | ['A' - 'Z']
let number = ['0' - '9']
let ident = letter (letter | number | '_')*

rule token = parse
  [ '\n' ] {newline lexbuf;token lexbuf}
| [' ' '\t' '\r' '\000'] {token lexbuf}
| ( '%' [^'%']* '%') {token lexbuf}
| "=" {ASSIGN}
| "define"	{DEF}
| "axiom" {VAR}
| "macro" {MAC}
| "system" {SYSTEM}
| ":" {COLON}
| ";" {SEMICOLON}
| "," {COMMA}
| "->" {ARROW}
| "=" {ASSIGN}
| "(" {LPAR}
| ")" {RPAR}
| "[" {LBRA}
| "]" {RBRA}
| "{" {LACC}
| "}" {RACC}
| "." {DOT}
| ident {IDENT(Lexing.lexeme lexbuf)}
| eof {reset ();END}

and systoken = parse
  [ '\n' ] {newline lexbuf;systoken lexbuf}
| [' ' '\t' '\r' '\000'] {systoken lexbuf}
| ( '%' [^'%']* '%') {systoken lexbuf}
| "sorts" {SORTS}
| "axioms" {AXIOMS}
| "rules" {RULES}
| ":" {COLON}
| "," {COMMA}
| "->" {ARROW}
| ident {IDENT(Lexing.lexeme lexbuf)}
| eof {reset ();END}
